/***
  ANZX}N(œK̓RpCɂ΂Ă炤)
  d s*b,u*̎GPRAf*b,d*b̎FPR 鎖B
***/

#define MEM_FETCH    0x00000001
#define MEM_STORE    0x00000002
#define MEM_DACCESS  0x00000010
#define MEM_IACCESS  0x00000020
#define MEM_1B       0x00000100
#define MEM_2B       0x00000200
#define MEM_4B       0x00000400
#define MEM_8B       0x00000800

int          __memaccess_mode ;
unsigned int __ea_for_exception ;
unsigned int __pa_for_exception ;

#ifdef SUPPORT_MMU_ADRS_TRANSRATION
int	adtr_func( struct MACHINE_RESOURCE *mres , int *pa, unsigned int ea ) ;
#else
#define adtr_func(m,p,l)  {*(p)=l ;}
#endif

#define seg(a)  (((a) & 0xf0000000)>>28)
#define lad(a)  ((a) & 0x0fffffff)


#ifdef HOST_ORDER_IS_LITTLE_ENDIAN
#define	fetchu1b(d,a)	{unsigned char *uc;\
                         int ad;\
                         int res;\
                         d=0;uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_FETCH|MEM_DACCESS|MEM_1B);\
                         if( (res=adtr_func(mres,&ad,(a)))!=NORMAL_EXIT ) return(res) ;\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         uc[0]=mres->mem[seg(ad)][lad(ad)+0];\
                         }
#define	fetchs2b(d,a)	{unsigned char *uc;\
                         int ad;\
                         int res;\
                         d=0;uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_FETCH|MEM_DACCESS|MEM_2B);\
                         if( (res=adtr_func(mres,&ad,(a)))!=NORMAL_EXIT ) return(res) ;\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         uc[0]=mres->mem[seg(ad)][lad(ad)+1];\
                         uc[1]=mres->mem[seg(ad)][lad(ad)+0];\
                         if( (uc[1]&0x80)!=0 ){\
                           uc[2]=0xff;uc[3]=0xff;\
                         }}
#define	fetchu2b(d,a)	{unsigned char *uc;\
                         int ad;\
                         int res;\
                         d=0;uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_FETCH|MEM_DACCESS|MEM_2B);\
                         if( (res=adtr_func(mres,&ad,(a)))!=NORMAL_EXIT ) return(res) ;\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         uc[0]=mres->mem[seg(ad)][lad(ad)+1];\
	                 uc[1]=mres->mem[seg(ad)][lad(ad)+0];\
                         }
#define	fetchu4b(d,a)	{unsigned char *uc;\
                         int ad;\
                         int res;\
                         d=0;uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_FETCH|MEM_DACCESS|MEM_4B);\
                         if( (res=adtr_func(mres,&ad,(a)))!=NORMAL_EXIT ) return(res) ;\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         uc[0]=mres->mem[seg(ad)][lad(ad)+3];\
                         uc[1]=mres->mem[seg(ad)][lad(ad)+2];\
                         uc[2]=mres->mem[seg(ad)][lad(ad)+1];\
                         uc[3]=mres->mem[seg(ad)][lad(ad)+0];\
                         }
#define	ifetchu4b(d,a)	{unsigned char *uc;\
                         int ad;\
                         int res;\
                         d=0;uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_FETCH|MEM_IACCESS|MEM_4B);\
                         if( (res=adtr_func(mres,&ad,(a)))!=NORMAL_EXIT ) return(res) ;\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         uc[0]=mres->mem[seg(ad)][lad(ad)+3];\
                         uc[1]=mres->mem[seg(ad)][lad(ad)+2];\
                         uc[2]=mres->mem[seg(ad)][lad(ad)+1];\
                         uc[3]=mres->mem[seg(ad)][lad(ad)+0];\
                         }
#define	fetchf4b(d,a)	{unsigned char *uc;\
                         int ad;\
                         int res;\
                         float f ;\
                         uc=(unsigned char *)&f;\
                         __memaccess_mode=(MEM_FETCH|MEM_DACCESS|MEM_4B);\
                         if( (res=adtr_func(mres,&ad,(a)))!=NORMAL_EXIT ) return(res) ;\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         uc[0]=mres->mem[seg(ad)][lad(ad)+3];\
                         uc[1]=mres->mem[seg(ad)][lad(ad)+2];\
                         uc[2]=mres->mem[seg(ad)][lad(ad)+1];\
                         uc[3]=mres->mem[seg(ad)][lad(ad)+0];\
                         d=f;}
#define	fetchd8b(d,a)	{unsigned char *uc;\
                         int ad;\
                         int res;\
                         d=0;uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_FETCH|MEM_DACCESS|MEM_8B);\
                         if( (res=adtr_func(mres,&ad,(a)))!=NORMAL_EXIT ) return(res) ;\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         uc[0]=mres->mem[seg(ad)][lad(ad)+7];\
                         uc[1]=mres->mem[seg(ad)][lad(ad)+6];\
                         uc[2]=mres->mem[seg(ad)][lad(ad)+5];\
                         uc[3]=mres->mem[seg(ad)][lad(ad)+4];\
                         uc[4]=mres->mem[seg(ad)][lad(ad)+3];\
                         uc[5]=mres->mem[seg(ad)][lad(ad)+2];\
                         uc[6]=mres->mem[seg(ad)][lad(ad)+1];\
                         uc[7]=mres->mem[seg(ad)][lad(ad)+0];\
                         }

#define	storeu1b(d,a)	{unsigned char *uc;\
                         int ad;\
                         int res;\
                         uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_STORE|MEM_DACCESS|MEM_1B);\
                         if( (res=adtr_func(mres,&ad,(a)))!=NORMAL_EXIT ) return(res) ;\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         mres->mem[seg(ad)][lad(ad)+0]=uc[0];\
			 }
#define	storeu2b(d,a)	{unsigned char *uc;\
                         int ad;\
                         int res;\
                         uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_STORE|MEM_DACCESS|MEM_2B);\
                         if( (res=adtr_func(mres,&ad,(a)))!=NORMAL_EXIT ) return(res) ;\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         mres->mem[seg(ad)][lad(ad)+0]=uc[1];\
                         mres->mem[seg(ad)][lad(ad)+1]=uc[0];\
			 }
#define	storeu4b(d,a)	{unsigned char *uc;\
                         int ad;\
                         int res;\
                         uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_STORE|MEM_DACCESS|MEM_4B);\
                         if( (res=adtr_func(mres,&ad,(a)))!=NORMAL_EXIT ) return(res) ;\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         mres->mem[seg(ad)][lad(ad)+0]=uc[3];\
                         mres->mem[seg(ad)][lad(ad)+1]=uc[2];\
                         mres->mem[seg(ad)][lad(ad)+2]=uc[1];\
                         mres->mem[seg(ad)][lad(ad)+3]=uc[0];\
			 }
#define	storef4b(d,a)	{unsigned char *uc;\
                         int ad;\
                         int res;\
                         float f;\
                         f=d;uc=(unsigned char *)&f;\
                         __memaccess_mode=(MEM_STORE|MEM_DACCESS|MEM_4B);\
                         if( (res=adtr_func(mres,&ad,(a)))!=NORMAL_EXIT ) return(res) ;\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         mres->mem[seg(ad)][lad(ad)+0]=uc[3];\
                         mres->mem[seg(ad)][lad(ad)+1]=uc[2];\
                         mres->mem[seg(ad)][lad(ad)+2]=uc[1];\
                         mres->mem[seg(ad)][lad(ad)+3]=uc[0];\
			 }
#define	stored8b(d,a)	{unsigned char *uc;\
                         int ad;\
                         int res;\
                         uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_STORE|MEM_DACCESS|MEM_8B);\
                         if( (res=adtr_func(mres,&ad,(a)))!=NORMAL_EXIT ) return(res) ;\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         mres->mem[seg(ad)][lad(ad)+0]=uc[7];\
                         mres->mem[seg(ad)][lad(ad)+1]=uc[6];\
                         mres->mem[seg(ad)][lad(ad)+2]=uc[5];\
                         mres->mem[seg(ad)][lad(ad)+3]=uc[4];\
                         mres->mem[seg(ad)][lad(ad)+4]=uc[3];\
                         mres->mem[seg(ad)][lad(ad)+5]=uc[2];\
                         mres->mem[seg(ad)][lad(ad)+6]=uc[1];\
                         mres->mem[seg(ad)][lad(ad)+7]=uc[0];\
			 }
#else
#define	fetchu1b(d,a)	{unsigned char *uc;\
                         int ad;\
                         int res;\
                         d=0;uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_FETCH|MEM_DACCESS|MEM_1B);\
                         if( (res=adtr_func(mres,&ad,(a)))!=NORMAL_EXIT ) return(res) ;\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         uc[3]=mres->mem[seg(ad)][lad(ad)+0];\
                         }
#define	fetchs2b(d,a)	{unsigned char *uc;\
                         int ad;\
                         int res;\
                         d=0;uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_FETCH|MEM_DACCESS|MEM_2B);\
                         if( (res=adtr_func(mres,&ad,(a)))!=NORMAL_EXIT ) return(res) ;\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         uc[2]=mres->mem[seg(ad)][lad(ad)+0];\
                         uc[3]=mres->mem[seg(ad)][lad(ad)+1];\
                         if( (uc[2]&0x80)!=0 ){\
                           uc[0]=0xff;uc[1]=0xff;\
                         }}
#define	fetchu2b(d,a)	{unsigned char *uc;\
                         int ad;\
                         int res;\
                         d=0;uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_FETCH|MEM_DACCESS|MEM_2B);\
                         if( (res=adtr_func(mres,&ad,(a)))!=NORMAL_EXIT ) return(res) ;\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         uc[2]=mres->mem[seg(ad)][lad(ad)+0];\
	                 uc[3]=mres->mem[seg(ad)][lad(ad)+1];\
                         }
#define	fetchu4b(d,a)	{unsigned char *uc;\
                         int ad;\
                         int res;\
                         d=0;uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_FETCH|MEM_DACCESS|MEM_4B);\
                         if( (res=adtr_func(mres,&ad,(a)))!=NORMAL_EXIT ) return(res) ;\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         uc[0]=mres->mem[seg(ad)][lad(ad)+0];\
                         uc[1]=mres->mem[seg(ad)][lad(ad)+1];\
                         uc[2]=mres->mem[seg(ad)][lad(ad)+2];\
                         uc[3]=mres->mem[seg(ad)][lad(ad)+3];\
                         }
#define	ifetchu4b(d,a)	{unsigned char *uc;\
                         int ad;\
                         int res;\
                         d=0;uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_FETCH|MEM_IACCESS|MEM_4B);\
                         if( (res=adtr_func(mres,&ad,(a)))!=NORMAL_EXIT ) return(res) ;\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         uc[0]=mres->mem[seg(ad)][lad(ad)+0];\
                         uc[1]=mres->mem[seg(ad)][lad(ad)+1];\
                         uc[2]=mres->mem[seg(ad)][lad(ad)+2];\
                         uc[3]=mres->mem[seg(ad)][lad(ad)+3];\
                         }
#define	fetchf4b(d,a)	{unsigned char *uc;\
                         int ad;\
                         int res;\
                         float f ;\
                         uc=(unsigned char *)&f;\
                         __memaccess_mode=(MEM_FETCH|MEM_DACCESS|MEM_4B);\
                         if( (res=adtr_func(mres,&ad,(a)))!=NORMAL_EXIT ) return(res) ;\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         uc[0]=mres->mem[seg(ad)][lad(ad)+0];\
                         uc[1]=mres->mem[seg(ad)][lad(ad)+1];\
                         uc[2]=mres->mem[seg(ad)][lad(ad)+2];\
                         uc[3]=mres->mem[seg(ad)][lad(ad)+3];\
                         d=f;}
#define	fetchd8b(d,a)	{unsigned char *uc;\
                         int ad;\
                         int res;\
                         d=0;uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_FETCH|MEM_DACCESS|MEM_8B);\
                         if( (res=adtr_func(mres,&ad,(a)))!=NORMAL_EXIT ) return(res) ;\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         uc[0]=mres->mem[seg(ad)][lad(ad)+0];\
                         uc[1]=mres->mem[seg(ad)][lad(ad)+1];\
                         uc[2]=mres->mem[seg(ad)][lad(ad)+2];\
                         uc[3]=mres->mem[seg(ad)][lad(ad)+3];\
                         uc[4]=mres->mem[seg(ad)][lad(ad)+4];\
                         uc[5]=mres->mem[seg(ad)][lad(ad)+5];\
                         uc[6]=mres->mem[seg(ad)][lad(ad)+6];\
                         uc[7]=mres->mem[seg(ad)][lad(ad)+7];\
                         }

#define	storeu1b(d,a)	{unsigned char *uc;\
                         int ad;\
                         int res;\
                         uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_STORE|MEM_DACCESS|MEM_1B);\
                         if( (res=adtr_func(mres,&ad,(a)))!=NORMAL_EXIT ) return(res) ;\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         mres->mem[seg(ad)][lad(ad)+0]=uc[3];\
			 }
#define	storeu2b(d,a)	{unsigned char *uc;\
                         int ad;\
                         int res;\
                         uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_STORE|MEM_DACCESS|MEM_2B);\
                         if( (res=adtr_func(mres,&ad,(a)))!=NORMAL_EXIT ) return(res) ;\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         mres->mem[seg(ad)][lad(ad)+0]=uc[2];\
                         mres->mem[seg(ad)][lad(ad)+1]=uc[3];\
			 }
#define	storeu4b(d,a)	{unsigned char *uc;\
                         int ad;\
                         int res;\
                         uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_STORE|MEM_DACCESS|MEM_4B);\
                         if( (res=adtr_func(mres,&ad,(a)))!=NORMAL_EXIT ) return(res) ;\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         mres->mem[seg(ad)][lad(ad)+0]=uc[0];\
                         mres->mem[seg(ad)][lad(ad)+1]=uc[1];\
                         mres->mem[seg(ad)][lad(ad)+2]=uc[2];\
                         mres->mem[seg(ad)][lad(ad)+3]=uc[3];\
			 }
#define	storef4b(d,a)	{unsigned char *uc;\
                         int ad;\
                         int res;\
                         float f;\
                         f=d;uc=(unsigned char *)&f;\
                         __memaccess_mode=(MEM_STORE|MEM_DACCESS|MEM_4B);\
                         if( (res=adtr_func(mres,&ad,(a)))!=NORMAL_EXIT ) return(res) ;\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         mres->mem[seg(ad)][lad(ad)+0]=uc[0];\
                         mres->mem[seg(ad)][lad(ad)+1]=uc[1];\
                         mres->mem[seg(ad)][lad(ad)+2]=uc[2];\
                         mres->mem[seg(ad)][lad(ad)+3]=uc[3];\
			 }
#define	stored8b(d,a)	{unsigned char *uc;\
                         int ad;\
                         int res;\
                         uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_STORE|MEM_DACCESS|MEM_8B);\
                         if( (res=adtr_func(mres,&ad,(a)))!=NORMAL_EXIT ) return(res) ;\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         mres->mem[seg(ad)][lad(ad)+0]=uc[0];\
                         mres->mem[seg(ad)][lad(ad)+1]=uc[1];\
                         mres->mem[seg(ad)][lad(ad)+2]=uc[2];\
                         mres->mem[seg(ad)][lad(ad)+3]=uc[3];\
                         mres->mem[seg(ad)][lad(ad)+4]=uc[4];\
                         mres->mem[seg(ad)][lad(ad)+5]=uc[5];\
                         mres->mem[seg(ad)][lad(ad)+6]=uc[6];\
                         mres->mem[seg(ad)][lad(ad)+7]=uc[7];\
			 }
#endif /**LITTLE_ENDIAN**/

int	memory_copy( struct MACHINE_RESOURCE *, int, int, int ) ;
