/**********************************************************************
  el̐ݒR}h
  $Id: set_cmd.c,v 1.2 2002/02/18 13:57:02 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "set_def.h"

int	set_mem( struct MACHINE_RESOURCE *mres, int, unsigned char *, int ) ;

int	set_cmd( struct TOKEN_STRUCT *tk_pt , int mode )
{
struct	TARGET_TBL_STRUCT{
	char  *name ;
	int   flag ;
} ;
static struct TARGET_TBL_STRUCT trg_tbl[] = {
#include "set_tbl.h"
	{ NULL			, 0 } /*** e[uI[ ***/
} ;

int i ;
int flag ;
int id ;

 id=proc_list.cur_id ;

 if( tk_pt->pt[1]==NULL || tk_pt->pt[2]==NULL ){
   fprintf(simmsgfp,"sĂ܂\n") ;
   return(SPECIFY_ERROR) ;
 }
 
 for( i=0 ; ; i++ ){
   if( trg_tbl[i].name==NULL ){
     fprintf(simmsgfp,"Ɍ肪܂(%s)\n",tk_pt->pt[1]) ;
     return(SPECIFY_ERROR) ;
   }
   if( strncmp(tk_pt->pt[1],"spr",3)==0 ){
     flag=SET_SPR0+ exatoi( &(tk_pt->pt[1])[3] ) ;
     break ;
   }else if( strcmp(tk_pt->pt[1],trg_tbl[i].name)==0 ){
     flag=trg_tbl[i].flag ;
     break ;
   }
 }
 
 if( flag==SET_PC ){                                    /** PC̐ݒ **/
   proc_list.proc[id].pc = exatoi(tk_pt->pt[2]) ;
   iexe_count  = 0 ;
   fprintf(simmsgfp,"pc=%x and Reset execed instruction count.\n",proc_list.proc[id].pc) ;
   return(NORMAL_EXIT) ;
 }
 if( flag==SET_XER ){                                   /** XER̐ݒ **/
   proc_list.proc[id].FLGR.xer = exatoi(tk_pt->pt[2]) ;
   fprintf(simmsgfp,"exr=%x\n",proc_list.proc[id].FLGR.xer) ;
   return(NORMAL_EXIT) ;
 }
 if( flag>=SET_R0 && flag<=SET_R31 ){                   /** GPR̐ݒ **/
   proc_list.proc[id].GPR[flag-SET_R0].rl=(unsigned int)exatoi(tk_pt->pt[2]) ;
   fprintf(simmsgfp,"r%d=%x\n",flag-SET_R0,proc_list.proc[id].GPR[flag-SET_R0].rl) ;
   return(NORMAL_EXIT) ;
 }
 if( flag>=SET_F0 && flag<=SET_F31 ){                   /** FPR̐ݒ **/
   proc_list.proc[id].FPR[flag-SET_F0].f=(unsigned int)exatoi(tk_pt->pt[2]) ;
   fprintf(simmsgfp,"f%d=%f\n",flag-SET_F0,proc_list.proc[id].FPR[flag-SET_F0].f) ;
   return(NORMAL_EXIT) ;
 }
 if( flag>=SET_SPR0 && flag<=SET_SPR1023 ){             /** SPR̐ݒ **/
   *proc_list.proc[id].SPR[flag-SET_SPR0]=(unsigned int)exatoi(tk_pt->pt[2]) ;
   fprintf(simmsgfp,"spr%d=0x%08x\n",flag-SET_SPR0,*proc_list.proc[id].SPR[flag-SET_SPR0]) ;
   return(NORMAL_EXIT) ;
 }
 if( flag==SET_MEM ){                                   /** ̐ݒ **/
   int	count ;
   int	st_adrs ;
   
   st_adrs=exatoi(tk_pt->pt[2]) ;
   if( lad(st_adrs)>=proc_list.proc[id].mem_size[seg(st_adrs)] ){
     fprintf(simmsgfp,"ȃJnʒuw肳܂\n") ;
     return(SPECIFY_ERROR) ;
   }
   if( tk_pt->pt[3]==NULL ){
     fprintf(simmsgfp,"f[^񂪎w肳Ă܂\n") ;
     return(SPECIFY_ERROR) ;
   }
   if( tk_pt->pt[4]==NULL ) count=1 ;
   else{
     count=exatoi(tk_pt->pt[4]) ;
     if( count<=0 ){
       fprintf(simmsgfp,"ȃJEgw肳܂\n") ;
       return(SPECIFY_ERROR) ;
     }
   }
   set_mem( &proc_list.proc[id], st_adrs, tk_pt->pt[3], count ) ;
   return(NORMAL_EXIT) ;
 }
 if( flag==SET_HEAPTOP ){ /** HEAP擪AhX̐ݒ **/
   proc_list.proc[id].heap_top  = exatoi(tk_pt->pt[2]) ;
   proc_list.proc[id].heap_size = 0 ;
   fprintf(simmsgfp,"heap_top=0x%x and size is reseted.\n",proc_list.proc[id].heap_top) ;
   return(NORMAL_EXIT) ;
 }
 
 return(NORMAL_EXIT) ;
}
