/**********************************************************************
  g[XqXg[_v
  $Id: td_cmd.c,v 1.3 2002/03/02 16:44:02 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"

#define DISP_PC   0
#define DISP_DIS  1
#define BUFSIZE  16

int td_cmd( struct TOKEN_STRUCT *tk_pt , int mode )
{
  int i,j,k ;
  int tp ;
  int dsp_mode ;
  int pc_cur, pc_prv, pc_dist ;
  unsigned char pcbuf_cur[BUFSIZE]  ;
  unsigned char pcbuf_prv[BUFSIZE]  ;
  unsigned char pcbuf[BUFSIZE]  ;
  struct MACHINE_RESOURCE tmp_proc ;

  pcbuf_cur[0]='\0' ; pcbuf_prv[0]='\0' ; pcbuf[0]='\0' ;
  pc_dist=0 ; pc_prv=0 ;

  tmp_proc=proc_list.proc[proc_list.cur_id] ;
  
  dsp_mode=DISP_PC ;
  if( tk_pt->pt[1]!=NULL ){
    if( strcmp(tk_pt->pt[1],"dis")==0 ){
      dsp_mode=DISP_DIS ;
    }
  }

  tp=trace_ptr ;
  for( j=0 ; j<HISTORY_SIZE/4 ; j++ ){
    for( i=0 ; i<4 ; i++ ){
      pc_cur=trace_history[tp].pc ;
      sprintf(pcbuf_cur,"%08x",pc_cur) ;
      if( tp==trace_ptr ){
	pc_prv=pc_cur ;
	strcpy(pcbuf_prv,pcbuf_cur) ;
	strcpy(pcbuf    ,pcbuf_cur) ;
      }else{
	pc_dist+=4 ;
	if( pc_cur!=(pc_prv+pc_dist) ){
	  pc_prv=pc_cur ;
	  pc_dist=0 ;
	  strcpy(pcbuf_prv,pcbuf_cur) ;
	  strcpy(pcbuf    ,pcbuf_cur) ;
	}else{
	  for( k=0 ; k<BUFSIZE ; k++ ){
	    if( pcbuf_prv[k]=='\0' ) break ;
	    if( pcbuf_cur[k]==pcbuf_prv[k] ){
	      pcbuf[k]='_' ;
	    }else{
	      strcpy(&pcbuf[k],&pcbuf_cur[k]) ;
	      break ;
	    }
	  }
	}
      }
      if( dsp_mode==DISP_DIS ){
	tmp_proc.pc=pc_cur ;
	op_exec(&tmp_proc,EXEC_DIS) ;
      }else{
	fprintf(simmsgfp,"%s(%08x)->",pcbuf,trace_history[tp].inst) ;
      }
      tp=(tp+1)%HISTORY_SIZE ;
    }
    if( dsp_mode==DISP_PC ){
      fprintf(simmsgfp,"\n") ;
    }
  }
  fprintf(simmsgfp,"Number of executed instructions=") ;
  printll(simmsgfp,iexe_count) ;
  fprintf(simmsgfp,"\n") ;
    
  return(NORMAL_EXIT) ;
}
